// Agent.hxx
//
/////////////////////////////////////////////////////////////////////////////

#ifndef AGENT_H
#define AGENT_H

#include "../librescue/input.h"
#include "../librescue/output.h"
#include "../librescue/connection.h"
#include "../librescue/udp.h"
#include <map>

using namespace Librescue;

namespace Rescue
{
  /////////////////////////////////////////////////////////////////////////
  // Agent

  /**
   * Уб륯饤Ȥ¸ߤ륪֥
   */
  class Agent
  {
  private:
        
  protected:
	/** 饤ȤΥɥ쥹 */
	//	LongUDPConnection* m_connection;
	Address m_clientAddress;
	RescueObject* m_object;

	/** γоʤФʤʤ */
	bool m_needsSensoryInformation;

	/** ޥ */
	Header m_commandType;
	int m_commandSize;
	Byte* m_commandBuffer;
        
  public:
	virtual ~Agent();
	Agent(/*LongUDPConnection* connection,*/ RescueObject* object);

	/** 饤ȤΥɥ쥹ꤹ */
	void setClientAddress(const Address& address);
	/** 饤ȤΥɥ쥹 */
	const Address& clientAddress() const;

	void setNeedsSensoryInformation(bool needsSensoryInformation);
	bool needsSensoryInformation() const;

	/** Object* إ㥹Ȥͤ */
	RescueObject* asObject() const;

	/** Agent 줿ޥɤɤ߹ǵ */
	void inputCommand(Header type, int size, Input& buffer);
	/** ޥɤεꥻåȤ롣getCommandType()  HEADER_NULL ֤褦ˤʤ */
	void resetCommand();
	/** ޥɤμ롣󥹥ȥ饯ľ HEADER_NULL ֤ */
	Header getCommandType() const;
	/** ޥɤ Simulator ؤѤ˥ХåեϤ */
	void outputCommand(Output& buffer) const;

	//	LongUDPConnection& getConnection() const;
        
  public:
	/** a cache for broadcasting of voices */
	Objects m_cacheForVoices;
	int m_radiusOfCacheForVoices;
	void resetCacheForVoices();
        
	/** far-fire-buildings information */
	std::map<Id,S32> m_farFireBuildingIDToSent;
        
  private:
	Agent(const Agent& source);
	Agent& operator= (const Agent& rhs);
	bool operator== (const Agent& rhs) const;
  };
    
  /////////////////////////////////////////////////////////////////////////
} // namespace Rescue

#endif // } !defined(AGENT_HXX__INCLUDED)
