#include "error.h"
#include <iostream>

namespace Librescue {
  char errorBuffer[BUFFER_LENGTH];

  void logError(const char* msg) {
	std::cerr << msg << std::endl;
  }

  void logWarning(const char* msg) {
	std::cout << msg << std::endl;
  }

  void logDebug(const char* msg) {
	std::cout << msg << std::endl;
  }

  void logInfo(const char* msg) {
	std::cout << msg << std::endl;
  }

  void dumpBytes(const char* bytes, int size) {
	char msg[128];
	for (int i=0;i<size;i+=4) {
	  snprintf(msg,128,"%d\t%02x\t%02x\t%02x\t%02x",i,bytes[i],bytes[i+1],bytes[i+2],bytes[i+3]);
	  std::cout << msg << std::endl;
	}
  }

  void dumpBytes(const Byte* bytes, int size) {
	char msg[128];
	for (int i=0;i<size;i+=4) {
	  snprintf(msg,128,"%d\t%02x\t%02x\t%02x\t%02x",i,bytes[i],bytes[i+1],bytes[i+2],bytes[i+3]);
	  std::cout << msg << std::endl;
	}
  }

  void dumpBytes(const Bytes& bytes) {
	char msg[128];
	int size = bytes.size();
	for (int i=0;i<size;i+=4) {
	  snprintf(msg,128,"%d\t%02x\t%02x\t%02x\t%02x",i,bytes[i],bytes[i+1],bytes[i+2],bytes[i+3]);
	  std::cout << msg << std::endl;
	}
  }

  void dumpBytes(Input& input) {
	Cursor start = input.cursor();
	Cursor current = start;
	char msg[128];
	while (current<(Cursor)input.size()) {
	  INT_32 next = input.readInt32();
	  snprintf(msg,128,"%d\t%02x\t%02x\t%02x\t%02x",current,(next>>24)&0xFF,(next>>16)&0xFF,(next>>8)&0xFF,next&0xFF);
	  std::cout << msg << std::endl;
	  current = input.cursor();
	}
	input.setCursor(start);
  }
}
